' Full Power Toolbox

' Demonstration Program (Version 3.00)

' Copyright 1992 - 1995 Information Management Systems, Inc.


' This demonstration program uses many of the functions and procedures in
' the Full Power Toolbox to show off the capabilities of the product.

' This program is also a good source of working examples of the routines
' in the library.


$COMPILE EXE "FPDemo.EXE"	' force compilation to FPDemo.EXE

$STRING 16		' required for proper use of some of the routines
$STACK 10240		' set the stack to 10k (unlikely to use this much, but we're being safe)

$LINK "FPTbx.PBL"		' link in the Full Power Toolbox Library
$INCLUDE "FPTypes.BAS"		' TYPE Definitions
$INCLUDE "FPTbx.DCL"		' DECLARE statements for all routines
$INCLUDE "FPColors.BAS"		' Color Constants


' Main Program Initialization
ON ERROR GOTO ErrorTrap		' initialize the error trap
StartScreen$ = SaveScreen$	' save the initial screen
StartCursorRow% = CSRLIN	' save the cursor position as well
StartCursorCol% = POS
Buttons% = InitializeMouse%	' initialize the mouse


' Initialize the online help system
Chk% = InitializeHelpM%("FPDemo.HLP", HelpFileNum%)
SELECT CASE Chk%
  CASE 1
    PRINT "Unable to find FPDemo.HLP.  Make sure it is in the default directory."
    END
  CASE 2
    PRINT "Incorrect file format for FPDemo.HLP"
    END
END SELECT


' Check for existence of FPTools.LST
IF LEN(DIR$("FPTools.LST")) = 0 THEN
  PRINT "Unable to find FPTools.LST.  Make sure it is in the default directory."
  END
END IF


' Create the Equates
%True = -1
%False = 0


' Array Initialization
DIM MenuChoice$(1:17), Keys?(1:17), Help$(1:17), Disabled?(1:17)
DIM ExitBox$(1:3), Picker$(1:45), SampleBox$(1:8), TimeOut$(1:2)
DIM DiskFull$(1:3), DiskError$(1:4), Selected%(1:45)

' Demo Control Variables
ExitDemo% = %False

' MenuChoice$() holds the Box Menu line entries, Keys?() holds the menu key
' letters, Help$() holds the line help for the main box menu

MenuChoice$(1)  = "Bar Menu"		: Keys?(1)  = 2  : Help$(1)  = "Sample Bar Menu"
MenuChoice$(2)  = "Box Menu"		: Keys?(2)  = 1  : Help$(2)  = "Sample Box Menu (you're using a Box Menu now)"
MenuChoice$(3)  = "Calendars"		: Keys?(3)  = 1  : Help$(3)  = "Calendars and Date Selection"
MenuChoice$(4)  = "Conversion Tools"	: Keys?(4)  = 3  : Help$(4)  = "Conversion Tools"
MenuChoice$(5)  = "Data Entry"		: Keys?(5)  = 6  : Help$(5)  = "Individual Data Entry Fields and Data Entry Screens"
MenuChoice$(6)  = "Date Tools"		: Keys?(6)  = 1  : Help$(6)  = "Date Tools"
MenuChoice$(7)  = "Dialog Boxes"	: Keys?(7)  = 6  : Help$(7)  = "Sample Dialog Box"
MenuChoice$(8)  = "Directory Pick List"	: Keys?(8)  = 16 : Help$(8)  = "Choose a File from a Pick List"
MenuChoice$(9)  = "File Viewer"		: Keys?(9) = 6   : Help$(9) = "View a File"
MenuChoice$(10) = "Help System"		: Keys?(10) = 1  : Help$(10) = "Explore the Help System"
MenuChoice$(11) = "Internal Tools"	: Keys?(11) = 1  : Help$(11) = "DOS and BIOS Internal Tools"
MenuChoice$(12) = "Keyboard Tools"	: Keys?(12) = 1  : Help$(12) = "Keyboard Handling Tools"
MenuChoice$(13) = "Mouse Control"	: Keys?(13) = 3  : Help$(13) = "Mouse Control and Input Routines"
MenuChoice$(14) = "Multi-Pick Pick List": Keys?(14) = 1  : Help$(14) = "Use a Multiple-Pick Pick List"
MenuChoice$(15) = "Pick List"		: Keys?(15) = 1  : Help$(15) = "Use a Pick List"
MenuChoice$(16) = "Screen Tools"	: Keys?(16) = 1  : Help$(16) = "Fancy Screen Handling Tools"
MenuChoice$(17) = "Windowing Tools"	: Keys?(17) = 1  : Help$(17) = "Powerful Windowing Tools"

ExitBox$(1) = "Are you sure you want to quit?"	' a Dialog Box message
ExitBox$(2) = ""
ExitBox$(3) = "Press Y or Esc to Quit, any other key to continue."
DIM ExBox AS WinAttr	' create an instance of the WinAttr type for use by the exit dialog box
' the UR, UC, LR, and LC fields are left set to 0 to force dynamic sizing
ExBox.Style = 1		' single line frame
ExBox.Title = 2		' title is centered on top line
ExBox.Shade = 2		' shadow drops down and to the right
ExBox.Shd = &H07	' white on black shadow
ExBox.Win = &H1F	' bright white on blue interior
ExBox.Frm = &H1E	' yellow on blue frame
ExBox.Ttl = &H1B	' light cyan on blue title

SampleBox$(1) = "This is a sample Dialog Box.  The box frame is"
SampleBox$(2) = "dynamically sized to accomodate the longest line"
SampleBox$(3) = "in the message.  Each line is centered within the"
SampleBox$(4) = "box, and the box may be automatically centered on"
SampleBox$(5) = "the screen or placed in a specific location."
SampleBox$(6) = ""
SampleBox$(7) = "You can even include blank lines and any ASCII"
SampleBox$(8) = "character (like " + CHR$(240) + ") in your message."

TimeOut$(1) = "Device time out.  Please correct the problem"
TimeOut$(2) = "then press any key to retry or Esc to abort."

DiskFull$(1) = "Disk is full."
DiskFull$(2) = ""
DiskFull$(3) = "Press any key to continue the demonstration."

DiskError$(1) = "Disk error.  Disk may be write-protected, drive door"
DiskError$(2) = "may be open, or there may be a serious fault with the"
DiskError$(3) = "disk drive controller.  Please correct the problem"
DiskError$(4) = "then press any key to retry or Esc to abort."

Picker$(1)  = "Elephant"	: Picker$(16) = "Cougar"	: Picker$(31) = "Falcon"
Picker$(2)  = "Cow"		: Picker$(17) = "Wolverine"	: Picker$(32) = "Chicken"
Picker$(3)  = "Pig"		: Picker$(18) = "Otter"		: Picker$(33) = "Sheep"
Picker$(4)  = "Horse"		: Picker$(19) = "Wildebeast"	: Picker$(34) = "Aardvark"
Picker$(5)  = "Hippopotamus"	: Picker$(20) = "Antelope"	: Picker$(35) = "Toucan"
Picker$(6)  = "Giraffe"		: Picker$(21) = "Gazelle"	: Picker$(36) = "Kiwi"
Picker$(7)  = "Beaver"		: Picker$(22) = "Squirrel"	: Picker$(37) = "Gnu"
Picker$(8)  = "Woodpecker"	: Picker$(23) = "Hawk"		: Picker$(38) = "Shark"
Picker$(9)  = "Cat"		: Picker$(24) = "Eagle"		: Picker$(39) = "Whale"
Picker$(10) = "Dog"		: Picker$(25) = "Ocelot"	: Picker$(40) = "Dolphin"
Picker$(11) = "Lion"		: Picker$(26) = "Chipmunk"	: Picker$(41) = "Hamster"
Picker$(12) = "Tiger"		: Picker$(27) = "Fox"		: Picker$(42) = "Mouse"
Picker$(13) = "Panther"		: Picker$(28) = "Weasel"	: Picker$(43) = "Rat"
Picker$(14) = "Rhinocerous"	: Picker$(29) = "Lizard"	: Picker$(44) = "Ferret"
Picker$(15) = "Leopard"		: Picker$(30) = "Goat"		: Picker$(45) = "Guinea Pig"


' Display the Opening Screen
COLOR %BrightWhite, %White	' use a bright white on white screen
CLS

' draw a frame on the screen, surrounded by a shadow
DIM Box AS WinAttr	' create an instance of the WinAttr type
Box.UR = 2	' the frame goes from row 2, column 2
Box.UC = 4
Box.LR = 23	' to row 23, column 78
Box.LC = 76
Box.Style = 4	' use a fancy frame
Box.Title = 2	' title goes on top line, centered
Box.Btn = 0	' no "close window" button
Box.Shade = 6	' thin shadow, down and to the right
Box.Shd = &H70	' black on white shadow
Box.Win = &H1F	' bright white on blue interior
Box.Frm = &H1E	' yellow on blue frame
Box.Ttl = &H1B	' light cyan on blue title
Title$ = "Demonstration Program"	' the title for the frame
CALL OpenWindow(Box, Title$, Save$)	' open a window on the screen

COLOR %LightRed, %Blue	' the name of the product goes in bright red on blue
LOCATE 4, 1
CALL CenterPrint("The Full Power Toolbox", 80)
COLOR %BrightWhite, %Blue	' the rest of the screen goes in bright white on blue
LOCATE 5, 1
CALL CenterPrint("Version 3.0", 80)
LOCATE 8, 1
CALL CenterPrint("Demonstration Program", 80)
LOCATE 11, 1
CALL CenterPrint("Copyright 1992 - 1995 Information Management Systems, Inc.", 80)
LOCATE 12,1
CALL CenterPrint("All rights reserved.", 80)
LOCATE 15, 1
CALL CenterPrint("Information Management Systems, Inc.", 80)
LOCATE 16, 1
CALL CenterPrint("1165 North Industrial Park Drive", 80)
LOCATE 17, 1
CALL CenterPrint("Orem, Utah  84057-2807", 80)
LOCATE 18, 1
CALL CenterPrint("(800) 750-6390 (Sales Department)", 80)
LOCATE 19, 1
CALL CenterPrint("(801) 226-6390", 80)
LOCATE 20, 1
CALL CenterPrint("(801) 226-6291 (Fax)", 80)
LOCATE 22, 1
CALL CenterPrint("Press any key to begin the demonstration.", 80)

WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke


' Main Program

DIM MBox AS WinAttr	' create an instance of the WinAttr type for the main menu
MBox.UR = 2	' box menu starts at row 2, column 28
MBox.UC = 28	' and is dynamically sized for the other coordinates
MBox.Style = 3	' use a fancy frame
MBox.Title = 2	' center the title on the top line
MBox.Shade = 2	' thick shadow down and to the right
MBox.Shd = &H07	' white on black shadow
MBox.Win = &H1F	' bright white on blue interior
MBox.Frm = &H1E	' yellow on blue frame
MBox.Ttl = &H1B	' light cyan on blue title
MTitle$ = "Demo Main Menu"
HelpRow? = 25	' display help messages on the bottom row of the screen
KeyAttr? = &H1E		' yellow on blue key letters
DisAttr? = &H10		' black on blue disabled menu items
HelpAttr? = &H7F	' bright white on white help messages
HighAttr? = &H71	' blue on white highlight bar

DIM HBox AS WinAttr	' create an instance of the WinAttr type for the help system
HBox.UR = 5	' help window is at row 5, column 5
HBox.UC = 5
HBox.LR = 20	' and extends to row 20
HBox.Style = 1	' single line frame
HBox.Title = 2	' center the title on the top line
HBox.Shade = 2	' thick shadow down and to the right
HBox.Shd = &H07	' white on black shadow
HBox.Win = &H1F	' bright white on blue interior
HBox.Frm = &H1E	' yellow on blue frame
HBox.Ttl = &H1B	' light cyan on blue title

DO	' main program loop
  COLOR %Black, %White	' black on white screen
  CLS
  IF Selected% >= 0 THEN	' only do this if the user had been on a menu item (rather than pressing Esc and saying No when asked to confirm)
    Initial? = Selected%	' start with the highlight bar on the last selected menu item
    IF Initial? = 0 THEN Initial? = 1	' this is our first trip to the menu, so start on the first item
  END IF
  Selected% = BoxMenuM%(MenuChoice$(), Keys?(), Help$(), Disabled?(), Initial?, MBox, MTitle$, HelpRow?, KeyAttr?, DisAttr?, HelpAttr?, HighAttr?)

  SELECT CASE Selected%		' evaluate selected Box Menu option
    CASE -1	' user pressed Esc
      Quit$ = DialogBox$(ExitBox$(), ExBox, "Confirm Quitting")
      IF INSTR(Quit$, ANY "Yy" + CHR$(27)) THEN ExitDemo% = %True	' user pressed Y, y, or Esc
    CASE 1	' Bar Menu
      CALL BarDemo
    CASE 2	' Box Menu
      CALL BoxDemo
    CASE 3	' Calendars
      CALL CalendarDemo
    CASE 4	' Conversion Tool
      CALL Convert
    CASE 5	' Data Entry
      CALL DataEntry
    CASE 6	' Date Tools
      CALL DateDemo
    CASE 7	' Dialog Box
      x$ = DialogBoxM$(SampleBox$(), ExBox, "Sample Dialog Box", 0)
    CASE 8	' Directory Pick List
      CALL Direct
    CASE 9	' File Viewer
      CALL Viewer
    CASE 10	' Help System
      Attr? = &H71	' blue on white highlight bar
      LinkAttr? = &H1E	' links are yellow on blue
      ActiveAttr? = &H5E	' active link is magenta on blue
      Invalid$ = " .,;:()-"
      CALL DisplayHelpM(HelpFileNum%, 0, 20, HBox, Attr?, LinkAttr?, ActiveAttr?, InvalidChars$)
    CASE 11	' Internal Tools
      CALL InternalDemo
    CASE 12	' Keyboard Tools
      CALL Keyboard
    CASE 13	' Mouse Control
      CALL MouseDemo
    CASE 14	' Multi-Pick Pick List
      CALL MultiPick
    CASE 15	' Pick List
      CALL PickDemo
    CASE 16	' Screen Tools
      CALL ScreenDemo
    CASE 17	' Windowing Tools
      CALL WindowDemo
  END SELECT
LOOP UNTIL ExitDemo%	' user pressed Esc

' Exit Demo program
COLOR %White, %Black	' default DOS colors (white on black)
CALL RestoreScreen(StartScreen$)	' restore the original DOS screen
LOCATE StartCursorRow%, StartCursorCol%	' place the cursor at the original location
PRINT "Thank you for your interest in the Full Power Toolbox!"
PRINT
PRINT "For a complete list of the functions and procedures in the Full Power"
PRINT "Toolbox, please refer to the file FPTools.LST."
END	' end of demo program



' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

' Supplemental Procedures (called by the SELECT CASE in response to the
' specific demo selected from the main Box Menu).

' These procedures call the actual tools from the Full Power Toolbox.

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


SUB BarDemo LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 16,1
  PRINT "  One of the two menu systems included in the Full Power Toolbox is the Bar"
  PRINT "  Menu Unit.  It displays dynamic bar menus, complete with key letter"
  PRINT "  selection and help messages attached to each menu choice.  As the"
  PRINT "  highlight bar is positioned on a choice, the help message is displayed"
  PRINT "  on the line of your choice.  (Of course, the help messages may be turned"
  PRINT "  off.)  The Run menu option has been disabled for this example."
  PRINT
  PRINT "  This bar menu is similar to the one in the PowerBASIC IDE."

  DIM DYNAMIC Choices$(1:7), Keys?(1:7), Help$(1:7), Disabled?(1:7)
  Choices$(1) = "File"    : Keys?(1) = 1 : Help$(1) = "File menu (save, shell, print, etc.)"
  Choices$(2) = "Edit"    : Keys?(2) = 1 : Help$(2) = "Editing menu (cut, copy, paste, etc.)"
  Choices$(3) = "Search"  : Keys?(3) = 1 : Help$(3) = "Search menu (find, replace, repeat search, etc.)"
  Choices$(4) = "Run"     : Keys?(4) = 1 : Help$(4) = "Run menu (run, trace into, reset program, etc.)"
  Choices$(5) = "Compile" : Keys?(5) = 1 : Help$(5) = "Compile menu (compile, find error, get info, etc.)"
  Choices$(6) = "Options" : Keys?(6) = 1 : Help$(6) = "IDE Options menu (compiler, linker, directories, etc.)"
  Choices$(7) = "Debug"   : Keys?(7) = 1 : Help$(7) = "Debug menu (evaluate, watches, break points, etc.)"
  Disabled?(4) = 1	' disable the Run menu
  Row? = 1	' display menu on top line of screen
  HelpRow? = 25	' display help messages on bottom line (when HelpRow? = 0, the help messages are not displayed)
  BarAttr? = &H5E	' yellow on magenta highlight bar
  MenuAttr? = &H1E	' yellow on blue menu bar
  KeyAttr? = &H1B	' light cyan on blue key letters
  DisAttr? = &H10	' black on blue disabled menu items
  HelpAttr? = &H71	' blue on white help messages
  DO
    IF Selected% THEN Initial? = Selected% ELSE Initial? = 1
    Selected% = BarMenuM%(Choices$(), Keys?(), Help$(), Disabled?(), Row?, HelpRow?, Initial?, BarAttr?, MenuAttr?, KeyAttr?, DisAttr?, HelpAttr?)
    IF Selected% = -1 THEN EXIT LOOP	' user pressed Esc
    LOCATE 10,1
    PRINT SPACE$(70);	' erase previous message
    LOCATE 10,1
    PRINT "You selected "; Choices$(Selected%);
  LOOP
  ERASE Choices$(), Keys?(), Help$(), Disabled?()
END SUB


SUB BoxDemo LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 16,1
  PRINT "  One of the two menu systems included in the Full Power Toolbox is the Box"
  PRINT "  Menu Unit.  It displays dynamic box menus, complete with key letter"
  PRINT "  selection and help messages attached to each menu choice.  As the"
  PRINT "  highlight bar is positioned on a choice, the help message is displayed"
  PRINT "  on the line of your choice.  (Of course, the help messages may be turned"
  PRINT "  off.)  The Run menu option has been disabled for this example."
  PRINT
  PRINT "  This box menu has similar choices to the menu in the PowerBASIC IDE."

  DIM DYNAMIC Choices$(1:7), Keys?(1:7), Help$(1:7), Disabled?(1:7)
  Choices$(1) = "File Menu"    : Keys?(1) = 1 : Help$(1) = "File menu (save, shell, print, etc.)"
  Choices$(2) = "Edit Menu"    : Keys?(2) = 1 : Help$(2) = "Editing menu (cut, copy, paste, etc.)"
  Choices$(3) = "Search Menu"  : Keys?(3) = 1 : Help$(3) = "Search menu (find, replace, repeat search, etc.)"
  Choices$(4) = "Run Menu"     : Keys?(4) = 1 : Help$(4) = "Run menu (run, trace into, reset program, etc.)"
  Choices$(5) = "Compile Menu" : Keys?(5) = 1 : Help$(5) = "Compile menu (compile, find error, get info, etc.)"
  Choices$(6) = "Options Menu" : Keys?(6) = 1 : Help$(6) = "IDE Options menu (compiler, linker, directories, etc.)"
  Choices$(7) = "Debug Menu"   : Keys?(7) = 1 : Help$(7) = "Debug menu (evaluate, watches, break points, etc.)"
  Disabled?(4) = 1	' disable the Run menu
  DIM Box AS LOCAL WinAttr	' create a local instance of the WinAttr type
  Box.UR = 5
  Box.UC = 10
  Box.Style = 15	' thin/thick line frame
  Box.Title = 2		' title goes on top line, centered
  Box.Shade = 6		' thin shadow, down and to the right
  Box.Shd = &H70	' black on white shadow
  Box.Win = &H1F	' bright white on blue interior
  Box.Frm = &H1E	' yellow on blue frame
  Box.Ttl = &H1B	' light cyan on blue title
  Title$ = "Box Menu"
  HelpRow? = 25		' display help messages on bottom line (when HelpRow? = 0, the help messages are not displayed)
  HighAttr? = &H5E	' yellow on magenta highlight bar
  KeyAttr? = &H1B	' light cyan on blue key letters
  DisAttr? = &H10	' black on blue disabled menu items
  HelpAttr? = &H71	' blue on white help messages

  DO
    IF Selected% THEN Initial? = Selected% ELSE Initial? = 1
    Selected% = BoxMenuM%(Choices$(), Keys?(), Help$(), Disabled?(), Initial?, Box, Title$, HelpRow?, KeyAttr?, DisAttr?, HelpAttr?, HighAttr?)
    IF Selected% = -1 THEN EXIT LOOP	' user pressed Esc
    LOCATE 1,1
    PRINT SPACE$(70);	' erase previous message
    LOCATE 1,1
    PRINT "You selected "; Choices$(Selected%);
  LOOP
  ERASE Choices$(), Keys?(), Help$(), Disabled?()
END SUB


SUB CalendarDemo LOCAL
  COLOR %Black, %White
  CLS
  ' place this month's calendar in the upper lefthand corner of the screen
  Row? = 2
  Col? = 2
  CALL SeparateDate(DATE$, Month?, Day?, Year%)	' get the components of the system date
  Title% = -1	' display the month and year
  DayLine% = -1	' display the day line
  CalAttr? = &H71	' blue on white calendar
  CurAttr? = &H74	' system date is red on white
  CALL Calendar(Row?, Col?, Month?, Year%, Title%, DayLine%, CalAttr?, CurAttr?)
  COLOR %Black, %White
  LOCATE 3,26
  PRINT "This calendar block is for the current month."
  LOCATE 4,26
  PRINT "It was displayed by the Calendar procedure."

  ' now display a scrolling calendar
  LOCATE 14,26
  PRINT "This calendar is a scrolling calendar.  It allows you"
  LOCATE 15,26
  PRINT "to change the month and year that are displayed.  To"
  LOCATE 16,26
  PRINT "change the month, press the Right or Left Arrow key;"
  LOCATE 17,26
  PRINT "to change the year, press the PgUp or PgDn key.  To"
  LOCATE 18,26
  PRINT "exit this calendar, press the Esc key."
  Row? = 12
  Col? = 2
  CALL ScrollingCalendar(Row?, Col?, Month?, Year%, DayLine%, Title%, CalAttr?, CurAttr?, EMonth?, EYear%)

  ' now display a selector calendar
  COLOR %Black, %White
  VIEW TEXT (1, 12) - (80, 22)	' clear the old calendar
  CLS
  VIEW TEXT (1, 1) - (80, 25)	' reset the view port
  LOCATE 14,26
  PRINT "This calendar is a selector calendar.  It allows you"
  LOCATE 15,26
  PRINT "to select a specific day from the calendar.  Use the"
  LOCATE 16,26
  PRINT "cursor keys to move the selector around the calendar."
  LOCATE 17,26
  PRINT "To change the month, press the Ctrl-Right or Ctrl-Left"
  LOCATE 18,26
  PRINT "Arrow key; to change the year, press the PgUp or PgDn"
  LOCATE 19,26
  PRINT "key.  To select the highlighted date, press the Enter"
  LOCATE 20,26
  PRINT "key.  To exit this calendar, press the Esc key."
  Row? = 12
  Col? = 2
  SelAttr? = &H17	' white on blue selector box
  DO
    CALL SelectorCalendar(Row?, Col?, Month?, Day?, Year%, DayLine%, Title%, CalAttr?, CurAttr?, SelAttr?, EMonth?, EDay?, EYear%)
    IF EDay? = 0 THEN EXIT LOOP
    COLOR %Black, %White
    LOCATE 24,1
    PRINT "You selected "; CreateDate$(EMonth?, EDay?, EYear%);
    Month? = EMonth?	' copy the ending date into the starting date
    Day? = EDay?
    Year% = EYear%
  LOOP
END SUB


SUB Convert LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox can convert numbers into their word equivalents."
  PRINT "  For example, 132 becomes `one hundred thirty-two'.  Try it now!"
  DIM Fld AS LOCAL FieldEdit	' create an instance of the FieldEdit type
  Fld.Row = 6	' put the field at row 6, column 5
  Fld.Col = 5
  Fld.Length = 6	' accept up to 6 characters
  Fld.Valid = 3		' signed numeric
  Fld.Mode = 3
  Fld.Echo = -1		' echo characters as typed
  Fld.PAttr = &H71	' blue on white prompt
  Fld.EAttr = &H4F	' bright white on red field
  Fld.DAttr = &H71	' blue on white field upon exit
  Prompt$ = "Enter a Number: "
  ExitKeys$ = CHR$(13,27)	' Enter and Esc are exit keys
  Cursor? = 0		' cursor starts at left edge of field
  InsertMode% = -1	' insert mode is on
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, Cursor?, InsertMode%)
  IF ASCII(Chk$) = 27 THEN EXIT SUB	' user pressed Esc
  Operand& = VAL(Entry$)
  COLOR %Blue, %White
  LOCATE 8,5
  PRINT NumberToWords$(Operand&)
  LOCATE 11,1
  COLOR %Black
  PRINT "  The Toolbox can also convert temperatures between Fahrenheit, Celsius,"
  PRINT "  and Kelvin.  Enter a Fahrenheit temperature now."
  Fld.Row = 14	' put the field at row 14, column 5 (column already set)
  Fld.Valid = 4		' signed floating point numeric
  Fld.Mode = 3
  Prompt$ = "Enter a Temperature: "
  Entry$ = ""
  Cursor? = 0		' cursor starts at left edge of field
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, Cursor?, InsertMode%)
  IF ASCII(Chk$) = 27 THEN EXIT SUB	' user pressed Esc
  Temper# = VAL(Entry$)
  COLOR %Blue
  LOCATE 16,5
  PRINT "Celsius equivalent:"; FahrToCels#(Temper#)
  PRINT "     Kelvin equivalent:"; FahrToKelv#(Temper#)
  PRINT
  COLOR %Black
  PRINT "  Press any key to return to the menu."
  WHILE LEN(INKEY$) = 0 : WEND
END SUB


SUB DataEntry LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox includes four powerful and flexible data entry"
  PRINT "  routines.  The individual data entry routines have been used throughout"
  PRINT "  this demo, whenever you have been asked to enter any kind of information."
  PRINT "  This screen contains several data entry fields, managed by the"
  PRINT "  EntryScreen function.  To return to the menu, press the Esc or F10 key."
  DIM Fld(1:8) AS LOCAL FieldEdit
  DIM Prompt$(1:8), FieldData$(1:8), Mask$(1:8)
  Prompt$(1) = "Enter your name, address, and phone number."
  Prompt$(2) = "First Name: "
  Prompt$(3) = "Last Name: "
  Prompt$(4) = "Address: "
  Prompt$(5) = "City: "
  Prompt$(6) = "State: "	' no other masks are used, so none others are specified
  Prompt$(7) = "Zip Code: "	: Mask$(7) = CHR$(1,1,1,1,1) + "-" + CHR$(1,1,1,1)
  Prompt$(8) = "Phone Number: " : Mask$(8) = "(" + CHR$(1,1,1) + ") " + CHR$(1,1,1) + "-" + CHR$(1,1,1,1)
  FOR c% = 1 TO 8	' cycle through the fields to set basic parameters
    Fld(c%).Row = c% + 9	' most fields start at this calculated row
    Fld(c%).Col = 3		' most fields start at column 3
    Fld(c%).Valid = 8		' any characters may be entered
    Fld(c%).Mode = 4		' normal editing; cursor may pass end of field
    Fld(c%).Echo = -1		' echo characters as they are entered
    Fld(c%).PAttr = &H71	' blue on white prompts
    Fld(c%).DAttr = &H74	' red on white data after editing field
    Fld(c%).EAttr = &H0B	' light cyan on black while editing
  NEXT c%
  Fld(1).Row = 9	' label field is on row 7
  Fld(6).Row = 14	' state and zip code are on row 13
  Fld(7).Row = 14
  Fld(8).Row = 15	' phone number is on row 14
  Fld(6).Col = 31	' state field is at column 31
  Fld(7).Col = 42	' zip code field is at column 42
  Fld(2).Length = 10	' first name is 10 characters long
  Fld(3).Length = 15	' last name is 15 characters long
  Fld(4).Length = 30	' address is 30 characters long
  Fld(5).Length = 20	' city is 20 characters long
  Fld(6).Length = 2	' state abbreviation is 2 characters long
  Fld(1).Valid = 255	' the first field is a label only field
  Fld(6).Valid = 6	' state is alphabetic; force to all caps
  Fld(7).Valid = 9	' zip code is a masked entry field
  Fld(8).Valid = 9	' phone number is a masked entry field
  Fld(6).Mode = 6	' normal editing; exit when cursor reaches end of field
  Fld(7).Mode = 6	' normal editing; exit when cursor reaches end of field
  Fld(8).Mode = 6	' normal editing; exit when cursor reaches end of field
  StartField% = 2	' start on the first name field
  MainExit$ = CHR$(27,0,68)	' exit keys are Esc and F10
  Repaint% = -1		' cause the fields to be redrawn upon entry
  InsertMode% = -1	' start with Insert Mode turned on
  Chk$ = EntryScreen$(Fld(), Prompt$(), FieldData$(), Mask$(), StartField%, MainExit$, Repaint%, InsertMode%, Modified%)
  IF ASCII(Chk$) = 27 THEN EndDataEntryDemo
  COLOR %Blue, %White
  LOCATE 18,1
  PRINT "  You pressed F10 to exit the entry screen."
  IF Modified% THEN
    PRINT "  You entered data in at least one field."	' we could check Fld().Change and see which individual fields were modified
  ELSE
    PRINT "  You did not enter data in any fields."
  END IF
  PRINT
  PRINT "  Press any key to return to the menu."
  WHILE LEN(INKEY$) = 0 : WEND

  EndDataEntryDemo:	' jump here upon Esc to erase arrays and return to menu
    ERASE Fld(), Prompt$(), FieldData$(), Mask$()
END SUB


SUB DateDemo LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox contains an array of Date and Time manipulation"
  PRINT "  tools.  Using the Toolbox's functions and procedures, this program will"
  PRINT "  manipulate the date and time that you enter."
  DIM Fld AS LOCAL FieldEdit	' create an instance of the FieldEdit type
  Fld.Row = 7	' put the field at row 7, column 5
  Fld.Col = 5
  Fld.Mode = 3
  Fld.Echo = -1		' echo characters as typed
  Fld.PAttr = &H71	' blue on white prompt
  Fld.EAttr = &H4F	' bright white on red field
  Fld.DAttr = &H71	' blue on white field upon exit
  Prompt$ = "Enter your birthdate: "	' prompt for the field
  Mask$ = CHR$(1,1) + "/" + CHR$(1,1) + "/19" + CHR$(1,1)	' field looks like "00/00/1900"
  ExitKeys$ = CHR$(13,27)	' Enter and Esc are exit keys
  Chk$ = MaskedEntry$(Fld, Prompt$, Mask$, Entry$, ExitKeys$)
  IF ASCII(Chk$) = 27 THEN EXIT SUB	' user pressed Esc
  ' print the birthdate in all available formats
  LOCATE 9,1
  COLOR %Blue, %White
  PRINT "  Dates can be formatted in each of these ways:"
  PRINT
  FOR Format? = 1 TO 12
    IF Format? > 8 THEN Separator$ = " " ELSE Separator$ = "/"
    PRINT TAB(5) FormatDate$(Entry$, Format?, Separator$)
  NEXT Format?
  PRINT
  PRINT "  Press any key to continue."
  WHILE LEN(INKEY$) = 0 : WEND
  COLOR %Black, %White
  CLS
  LOCATE 3,3
  PRINT "The Julian number of your birthdate is"; JulianNumber&(Entry$)
  PRINT "  You were born on a "; DayWeek$(Entry$)
  PRINT "  You are"; ABS(ElapsedDays&(Entry$, DATE$)); "days old."
  PRINT
  PRINT
  PRINT "  The Toolbox can perform other manipulations as well, such as adding"
  PRINT "  or subtracting days from a date to get a new day."
  Fld.Row = 13	' put the field at row 13, column 5
  Fld.Length = 4	' accept up to 4 digits
  Fld.Valid = 3		' signed numeric
  Prompt$ = "Number of Days: "
  Cursor? = 0		' cursor starts at left edge of field
  InsertMode% = -1	' insert mode is on
  Entry$ = ""
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, Cursor?, InsertMode%)
  IF ASCII(Chk$) = 27 THEN EXIT SUB	' user pressed Esc
  Operand% = VAL(Entry$)
  LOCATE 15,3
  COLOR %Blue, %White
  PRINT "The date, in"; Operand%; "days, will be (or was): "; IncrDate$(DATE$, Operand%)
  PRINT
  PRINT "  Press any key to continue."
  WHILE LEN(INKEY$) = 0 : WEND
  ' now try the time tools
  COLOR %Black, %White
  CLS
  Fld.Row = 3	' put the field at row 3, column 3
  Fld.Col = 3
  Prompt$ = "Now enter a time (in HH:MM:SS military format): "
  Mask$ = CHR$(1,1) + ":" + CHR$(1,1) + ":" + CHR$(1,1) + "." + CHR$(1,1)	' field looks like "00:00:00.00"
  Entry$ = ""
  Chk$ = MaskedEntry$(Fld, Prompt$, Mask$, Entry$, ExitKeys$)
  IF ASCII(Chk$) = 27 THEN EXIT SUB	' user pressed Esc
  LOCATE 5,1
  COLOR %Blue, %White
  PRINT "  Times can be formatted in each of these ways:"
  PRINT
  FOR Format? = 1 TO 3
    PRINT TAB(5) FormatTime$(Entry$, Format?, 0, 0)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 1, 0)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 0, 1)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 1, 1)
  NEXT Format?
  PRINT
  PRINT "  That time occurred"; TimeToSeconds!(Entry$); "seconds after midnight."
  PRINT "  The elapsed time between that time and the current time is "; ElapsedTime$(Entry$, TIME$)
  PRINT
  PRINT "  Press any key to return to the menu."
  WHILE LEN(INKEY$) = 0 : WEND
END SUB


SUB Direct SHARED
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  This tool creates a Pick List of the files from a directory with a"
  PRINT "  given file specifier (such as *.TXT).  This demonstration will now"
  PRINT "  create a list of all the normal and read-only files in the current"
  PRINT "  directory.  The name of the file you select will be displayed at the"
  PRINT "  bottom of the screen.  To return to the menu, press the Esc key or"
  PRINT "  click the right mouse button."

  DIM Box AS LOCAL WinAttr	' create an instance of the WinAttr type for the directory pick list
  Box.UR = 10	' the upper corner of the box is at row 10, column 34
  Box.UC = 15
  Box.LR = 22	' the lower row is 22; the width is sized dynamically
  Box.Style = 2	' double line box frame
  Box.Title = 2	' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07	' white on black shadow
  Box.Win = &H1F	' bright white on blue interior
  Box.Frm = &H1E	' yellow on blue frame
  Box.Ttl = &H1B	' light cyan on blue title
  Scroll? = 1		' show the scroll bar
  FileMask$ = "*.*"
  FileAttrib% = 0	' normal and read-only files only
  FileList? = &B11111	' display all info in the list
  Separ$ = CHR$(179)	' use the vertical bar as a separator
  HighAttr? = &H71	' blue on white highlight bar
  DO
    File$ = DirectoryPickM$(Box, "Files", Scroll?, FileMask$, FileAttrib%, FileList?, Separ$, HighAttr?)
    LOCATE 25,2
    COLOR %Black, %White
    PRINT "File selected: "; File$;
  LOOP WHILE LEN(File$)
END SUB


SUB Viewer SHARED	' file viewer demo
  COLOR %Black, %White
  CLS
  ' display the directory pick list for the user
  DIM Box AS LOCAL WinAttr	' create an instance of the WinAttr type for the directory pick list
  Box.UR = 3	' the upper corner of the box is at row 10, column 34
  Box.UC = 15
  Box.LR = 22	' the lower row is 22; the width is sized dynamically
  Box.Style = 2	' double line box frame
  Box.Title = 2	' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07	' white on black shadow
  Box.Win = &H1F	' bright white on blue interior
  Box.Frm = &H1E	' yellow on blue frame
  Box.Ttl = &H1B	' light cyan on blue title
  Title$ = "Select a File to View"
  Scroll? = 1		' show the scroll bar
  FileMask$ = "*.*"
  FileAttrib% = 0	' normal and read-only files only
  FileList? = &B11111	' display all info in the list
  Separ$ = CHR$(179)	' use the vertical bar as a separator
  HighAttr? = &H71	' blue on white highlight bar
  File$ = DirectoryPickM$(Box, Title$, Scroll?, FileMask$, FileAttrib%, FileList?, Separ$, HighAttr?)
  IF LEN(File$) = 0 THEN EXIT SUB
  ' now set up and access the file viewer
  CALL Line25(CHR$(24) + ", " + CHR$(25) + ", PgUp, PgDn, ^ " + CHR$(26) + _
	      ", ^ " + CHR$(27) + ", Home, End, Alt-L, Esc to Exit")	' mini help for the file viewer
  Box.UR = 2
  Box.UC = 2
  Box.LR = 23
  Box.LC = 78
  Box.Style = 1
  Box.Shade = 6
  Box.Shd = &H70
  TabLen% = 8	' PowerBASIC default TAB stop
  Scroll? = 1	' display a scroll bar
  x% = ViewFileM%(File$, Box, TabLen%, Scroll?)
END SUB


SUB InternalDemo LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  In addition to the high level tools included in the Full Power Toolbox,"
  PRINT "  there are several low level tools, many of which use low level DOS and"
  PRINT "  BIOS services to give your program information and control that"
  PRINT "  PowerBASIC cannot give you directly."
  PRINT
  COLOR %Blue, %White
  PRINT "  You are running under DOS version "; DOSVersion$(Major%, Minor%)
  IF VideoMode% = 7 THEN
    PRINT "  You are using a monochrome video adapter."
  ELSE
    PRINT "  You are using a color video adapter."
  END IF
  IF PrinterReady%(1) THEN
    PRINT "  The printer or device on LPT1 is ready."
  ELSE
    PRINT "  The printer or device on LPT1 is not ready."
  END IF
  PRINT "  You have"; BaseMemory%; "kb of base (conventional) memory."
  TotalEMS?? = ExpMemory??(FreeExp??)
  PRINT "  You have"; TotalEMS??; "kb of EMS memory installed with"; FreeExp??; "kb free."
  PRINT
  PRINT "  The name of this program is: "; GetProgramName$
  PRINT
  PRINT "  This program will now check the size of one of your drives."
  DIM Fld AS LOCAL FieldEdit	' create an instance of the FieldEdit type
  Fld.Row = 18	' put the field at row 16, column 3
  Fld.Col = 3
  Fld.Length = 1
  Fld.Valid = 6
  Fld.Mode = 3
  Fld.Echo = -1		' echo characters as typed
  Fld.PAttr = &H71	' blue on white prompt
  Fld.EAttr = &H4F	' bright white on red field
  Fld.DAttr = &H71	' blue on white field upon exit
  Prompt$ = "Enter a drive letter: "
  ExitKeys$ = CHR$(13,27)	' Enter and Esc are exit keys
  Cursor? = 0	' start at left edge of field
  InsertMode% = 0	' overwrite mode
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, Cursor?, InsertMode%)
  IF ASCII(Chk$) = 27 THEN EXIT SUB
  CALL GetFreeSpace(Entry$, ClusterSize%, TotalSpace&, FreeSpace&)
  COLOR %Blue, %White
  LOCATE 19,1
  IF ClusterSize% > 0 THEN
    PRINT "    Clusters are"; ClusterSize%; "bytes long."
    PRINT "    Total space available:"; USING$("#,###,###,###", TotalSpace&); " bytes."
    PRINT "    Free space available: "; USING$("#,###,###,###", FreeSpace&); " bytes."
  ELSE
    PRINT "    Invalid drive specifier."
  END IF
  PRINT
  PRINT "  Press any key to return to the menu."
  WHILE LEN(INKEY$) = 0 : WEND
END SUB


SUB Keyboard LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox contains several keyboard handling tools.  They"
  PRINT "  allow you to change the state of the Caps Lock, Num Lock, Scroll Lock,"
  PRINT "  and Insert Mode keyboard toggles, and check the status of each key flag."
  PRINT
  PRINT "  This program will now show you the status of each flag, continuously"
  PRINT "  updating the screen for each flag.  When you wish to return to the menu,"
  PRINT "  press the Esc key."
  COLOR %Blue, %White
  LOCATE 12,3
  PRINT "Right Shift key:"
  PRINT "  Left Shift key:"
  PRINT "  Control (Ctrl) key:"
  PRINT "  Alt key:"
  PRINT "  Scroll Lock:"
  PRINT "  Num Lock:"
  PRINT "  Caps Lock:"
  PRINT "  Insert Mode:"
  COLOR %BrightWhite, %White
  DO
    CALL KeyFlags(RShift?, LShift?, Ctrl?, Alt?, Scr?, Num?, Caps?, Insrt?)
    LOCATE 12,20
    IF RShift? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 13,19
    IF LShift? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 14,23
    IF Ctrl? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 15,12
    IF Alt? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 16,16
    IF Scr? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 17,13
    IF Num? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 18,14
    IF Caps? THEN PRINT "On "; ELSE PRINT "Off";
    LOCATE 19,16
    IF Insrt? THEN PRINT "On "; ELSE PRINT "Off";
  LOOP UNTIL ASCII(INKEY$) = 27
END SUB


SUB MouseDemo
  SHARED Buttons%
  COLOR %Black, %White
  CLS
  IF Buttons% = 0 THEN	' no mouse is installed
    PRINT "  You do not have a mouse or mouse driver installed, so this portion of"
    PRINT "  the demo will not show you anything.  Press any key to return to the"
    PRINT "  menu."
    WHILE LEN(INKEY$) = 0 : WEND
    EXIT SUB
  END IF
  PRINT "  The Full Power Toolbox gives you a large suite of mouse control routines."
  PRINT "  You can look for mouse events (such as button clicks or releases), check"
  PRINT "  the position of the mouse cursor, change the size and shape of the mouse"
  PRINT "  cursor, and more."
  PRINT
  COLOR %Blue
  CALL GetMouseInfo(Version$, MouseType%, IRQ%)
  PRINT "  You are using a";
  SELECT CASE MouseType%
    CASE 1	' bus mouse
      PRINT " Bus mouse."
    CASE 2	' serial mouse
      PRINT " Serial mouse."
    CASE 3	' InPort mouse
      PRINT "n InPort mouse."
    CASE 4	' PS/2 mouse
      PRINT " PS/2 mouse."
    CASE 5	' HP mouse
      PRINT "n HP mouse."
    CASE ELSE	' unknown type
      PRINT "Unknown type of mouse."
  END SELECT
  PRINT "  The mouse is attached to IRQ"; IRQ%
  PRINT "  The mouse driver is version "; Version$
  PRINT
  COLOR %Black
  PRINT "  The cursor you now see on the screen is the default text-mode mouse"
  PRINT "  cursor, but you can readily change it.  Press any key, and we'll show"
  PRINT "  you an example."
  PRINT
  CALL ShowMouse
  WHILE LEN(INKEY$) = 0 : WEND
  CursorType? = 0	' use a software cursor
  AndChar? = 0	' clear the current character
  XorChar? = 4	' use a diamond shape for the mouse
  AndAttr? = &B01110000	' mask out the foreground color
  XorAttr? = &H0E	' use a yellow foreground color
  CALL HideMouse	' hide the mouse cursor while we make the change
  CALL SetTextPointerType(CursorType?, StartLine?, EndLine?, AndAttr?, AndChar?, XorAttr?, XorChar?)
  PRINT "  You can also restrict the area of the screen in which the mouse cursor"
  PRINT "  can move.  Press any key, and the mouse cursor will be limited to the"
  PRINT "  upper right corner of the screen."
  PRINT
  CALL ShowMouse	' show the mouse cursor again
  WHILE LEN(INKEY$) = 0 : WEND
  Row? = 12	' translate these row and column settings into pixel values
  Col? = 40
  CALL PosToPixels(Row?, Col?, PixelX%, PixelY%)
  CALL SetHorizLimits(0, PixelX%)
  CALL SetVertLimits(0, PixelY%)
  CALL HideMouse
  IF BIT(pbvScrnCard, 5) = 0 THEN	' a VGA monitor is not in use
    PRINT "  Since you do not have a VGA monitor, we cannot show you the graphical"
    PRINT "  mouse cursors.  Press any key to return to the menu."
    CALL ShowMouse
    WHILE LEN(INKEY$) = 0 : WEND
    Chk% = ResetMouse%	' reset the mouse driver
    EXIT SUB
  END IF
  PRINT "  We will now show you the graphical mouse cursors.  Press any key to"
  PRINT "  change into graphics mode 12.  Once in graphics mode, click the left"
  PRINT "  mouse button to cycle the cursor through the three available cursors."
  CALL ShowMouse
  WHILE LEN(INKEY$) = 0 : WEND
  CALL HideMouse
  SCREEN 12
  CALL ShowMouse
  NextCursor? = 1
  DO	' wait for the use to press the left mouse button
    CALL GetButtonPressInfo(0, Status?, Presses??, XLoc%, YLoc%)
    IF Presses?? THEN	' the left mouse button has been pressed
      DO	' wait for the user to release the button
        CALL GetButtonReleaseInfo(0, Status?, Presses??, XLoc%, YLoc%)
      LOOP UNTIL Presses??
      CALL HideMouse	' hide the mouse cursor while we make the change
      SELECT CASE NextCursor?
        CASE 1	' crosshairs cursor
          CALL UseCrosshairsCursor
        CASE 2	' hourglass cursor
          CALL UseHourglassCursor
        CASE 3	' arrow cursor
          CALL UseArrowCursor
      END SELECT
      INCR NextCursor?
      CALL ShowMouse	' turn the mouse cursor back on
    END IF
  LOOP UNTIL NextCursor? > 4	' keep going until the user has seen all three cursor shapes
  CALL HideMouse
  SCREEN 0	' return to text mode
  Chk% = ResetMouse%	' reset the mouse driver
END SUB


SUB MultiPick LOCAL
  SHARED Picker$(), Selected%()
  COLOR %Black, %White
  CLS
  PRINT "  A Multi-Pick Pick List is a very powerful interface tool.  It allows you"
  PRINT "  to present a list of options to the user.  He or she can select all, some,"
  PRINT "  one, or none of the options.  These lists are ideal for selecting multiple"
  PRINT "  database records for inclusion in reports or searches, choosing program"
  PRINT "  configuration options, etc.  Each item in the list can begin selected or"
  PRINT "  unselected; just click on the item with the left mouse button or highlight"
  PRINT "  it and press the Enter key to toggle the selected state.  In addition to"
  PRINT "  the cursor keys, you can type a portion of a word in the list and jump"
  PRINT "  directly to that word.  Give it a try now:"
  DIM Box AS LOCAL WinAttr	' create an instance of the WinAttr type for the pick list box
  Box.UR = 11	' the upper corner of the box is at row 11, column 20
  Box.UC = 20
  Box.LR = 22	' the lower row is 22; the width is sized dynamically
  Box.Style = 1	' single line box frame
  Box.Title = 2	' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07	' white on black shadow
  Box.Win = &H1F	' bright white on blue interior
  Box.Frm = &H1E	' yellow on blue frame
  Box.Ttl = &H1B	' light cyan on blue title
  SortFlag% = 1		' sort list in ascending order
  Title$ = "Animals"
  Scroll? = 1		' show the scroll bar
  HighAttr? = &H71	' blue on white highlight bar
  SelAttr? = &H1E	' selected items are yellow on blue
  SelKey$ = CHR$(251)	' use a check mark for selected characters
  DO
    CALL MultiPickListM(Picker$(), Selected%(), SortFlag%, Box, Title$, Scroll?, HighAttr?, SelAttr?, SelKey$)
    COLOR %Blue, %White
    CLS
    Picked% = 0
    FOR i% = 1 TO 45
      IF Selected%(i%) THEN
	INCR Picked%
	PRINT Picker$(i%); TAB(20 * (Picked% MOD 4));
      END IF
    NEXT i%
    PRINT : PRINT
    PRINT "You selected"; Picked%;
    IF Picked% = 1 THEN
      PRINT "animal."
    ELSE
      PRINT "animals."
    END IF
    PRINT
    COLOR %Black
    PRINT "  Press Esc to return to the main menu, or any other key to display the multi-"
    PRINT "  pick pick list again (leaving the selected animals marked as selected)."
    WHILE NOT INSTAT : WEND
  LOOP UNTIL ASCII(INKEY$) = 27
END SUB


SUB PickDemo LOCAL
  SHARED Picker$()
  COLOR %Black, %White
  CLS
  PRINT "  A Pick List is a very powerful interface tool.  It allows you to present"
  PRINT "  a list of options to the user, reducing the typing the user must do.  They"
  PRINT "  can be used to select a database record, an option for an input field, or"
  PRINT "  any other situation where the user must pick one item from a list.  In"
  PRINT "  addition to the cursor keys, you can type a portion of a word in the list"
  PRINT "  and jump directly to that word.  Give it a try now:"
  DIM Box AS LOCAL WinAttr	' create an instance of the WinAttr type for the pick list box
  Box.UR = 8	' the upper corner of the box is at row 8, column 20
  Box.UC = 20
  Box.LR = 22	' the lower row is 22; the width is sized dynamically
  Box.Style = 1	' single line box frame
  Box.Title = 2	' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07	' white on black shadow
  Box.Win = &H1F	' bright white on blue interior
  Box.Frm = &H1E	' yellow on blue frame
  Box.Ttl = &H1B	' light cyan on blue title
  SortFlag% = 1		' sort list in ascending order
  Title$ = "Animals"
  Scroll? = 1		' show the scroll bar
  HighAttr? = &H71	' blue on white highlight bar
  DO
    Selected% = PickListM%(Picker$(), SortFlag%, Box, Title$, Scroll?, HighAttr?)
    IF Selected% = -1 THEN EXIT LOOP
    LOCATE 25,3
    COLOR %Blue, %White
    PRINT "You selected "; Picker$(Selected%); SPACE$(20);
  LOOP
END SUB


SUB ScreenDemo LOCAL
  COLOR %Black, %White
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox contains several routines that provide special"
  PRINT "  screen effects.  Several of them were written using PowerBASIC's inline"
  PRINT "  assembler for maximum speed.  In this section of the demo, the screen"
  PRINT "  will be recolored, then a section of the screen will be cleared, then"
  PRINT "  another section of the screen will be filled with asterisks, and finally"
  PRINT "  the screen will be `wiped' in two directions before returning to the"
  PRINT "  menu.  When you are ready to proceed, please press any key."
  WHILE LEN(INKEY$) = 0 : WEND
  ' recolor the screen
  Attr? = &H4F	' change the screen to bright white on red
  CALL Recolor(Attr?)
  COLOR %BrightWhite, %Red
  CALL Line25("Press any key to continue.")
  WHILE LEN(INKEY$) = 0 : WEND
  ' clear a portion of the screen
  URow% = 1	' clear the area from row 1, column 1
  LCol% = 1
  LRow% = 12	' to row 12, column 80
  RCol% = 80
  Attr? = &H27	' use white on green for the cleared section
  CALL PartialCLS(URow%, LCol%, LRow%, RCol%, Attr?)
  ' fill a different portion of the screen
  Char? = 42	' asterisk
  Attr? = &H17	' use white on blue
  DIM Coords AS LOCAL BoxSize	' create an instance of the BoxSize type for the screen area
  Coords.UR = 13	' fill the area from row 13, column 1
  Coords.UC = 1
  Coords.LR = 24	' to row 24, column 80
  Coords.LC = 80
  CALL ScreenFill(Char?, Attr?, Coords)
  CALL Line25("Press any key to continue.")
  WHILE LEN(INKEY$) = 0 : WEND
  ' now wipe the screen downward, then upward
  Attr% = &H11	' use blue on blue for the first wipe
  Direction% = 1	' wipe downward
  DelayFac! = 0
  CALL ScreenWipe(Attr%, Direction%, DelayFac!)
  DELAY .5
  Attr% = &H00	' use black on black for the second wipe
  Direction% = 2	' wipe upward
  CALL ScreenWipe(Attr%, Direction%, DelayFac!)
END SUB


SUB WindowDemo LOCAL
  COLOR %Black, %White
  CLS
  PRINT "  The Full Power Toolbox contains powerful windowing routines with lots of"
  PRINT "  options.  You get complete control of colors, shadowing (8 types), title"
  PRINT "  position (8 types), and frame styles (20 types).  Here are a few samples:"
  DIM Box AS LOCAL WinAttr	' create an instance of the WinAttr type for these example windows
  Title$ = "Demo"
  DIM Save$(1:8)	' this array will hold the saved screens
  FOR c% = 1 TO 8	' display 8 boxes on the screen
    IF c% < 5 THEN Box.UR = 6 ELSE Box.UR = 16
    Box.UC = (((c% - 1) MOD 4) * 19) + 4	' this formula calculates the upper left column of the box
    Box.LR = Box.UR + 7
    Box.LC = Box.UC + 13
    Box.Style = c%
    Box.Title = c%
    Box.Shade = c%
    IF c% < 5 THEN Box.Shd = &H07 ELSE Box.Shd = &H70	' set shadow attribute
    Box.Win = BuildAttr?((c% - 1), (c% - 1), 0)
    Box.Frm = BuildAttr?(15, (c% - 1), 0)	' frame is bright white on the background color
    Box.Ttl = BuildAttr?(14, (c% - 1), 0)	' title is yellow on the background color
    CALL OpenWindow(Box, Title$, Save$(c%))
  NEXT c%
  ' now remove the windows
  LOCATE 25,1
  PRINT "Press any key to remove the boxes.";
  WHILE LEN(INKEY$) = 0 : WEND
  FOR c% = 8 TO 1 STEP -1
    CALL RestoreScreen(Save$(c%))
  NEXT c%
  ERASE Save$()		' this array is no longer needed; reclaim the memory

  LOCATE 5,1
  PRINT "  You can also move a window around on the screen.  This program will"
  PRINT "  now draw a box on the screen and move it around at random until you"
  PRINT "  press the Esc key."
  Box.UR = 10		' set up the moving box
  Box.UC = 30
  Box.LR = 18
  Box.LC = 45
  Box.Style = 1
  Box.Title = 2
  Box.Shade = 6
  Box.Shd = &H70
  Box.Win = &H47
  Box.Frm = &H4E
  Box.Ttl = &H4F
  Title$ = "Moving Box"
  CALL OpenWindow(Box, Title$, Save$)
  RANDOMIZE TIMER
  Length? = 1
  DO
    Direction? = INT(RND * 4)
    SELECT CASE Direction?
      CASE 0	' left
        IF Box.UC < 5 THEN Direction? = 1
      CASE 1	' right
        IF Box.LC > 75 THEN Direction? = 0
      CASE 2	' up
        IF Box.UR < 3 THEN Direction? = 3
      CASE 3	' down
        IF Box.LR > 22 THEN Direction? = 2
    END SELECT
    CALL MoveWindow(Box, Direction?, Length?, Save$)
  LOOP UNTIL ASCII(INKEY$) = 27
END SUB


ErrorTrap:		' this subroutine handles run time errors

  DIM EBox AS WinAttr	' create an instance of the WinAttr type
  ' since all fields default to 0 and we want the dialog box dynamically
  ' sized, we are leaving the UR, UC, LR, and LC fields unset
  Box.Style = 1		' use a single line frame
  Box.Title = 2		' title is centered on top line
  Box.Btn = 1		' display the "close window" button
  Box.Shade = 6		' thin shadow that drops down and to the right
  Box.Shd = &H01	' shadow is black on blue
  Box.Win = &H70	' dialog box is black on white
  Box.Frm = &H7E	' frame is yellow on white
  Box.Ttl = &H7B	' title is bright red on white
  SELECT CASE ERR
    CASE 7
      COLOR %White, %Black
      CLS
      PRINT "Insufficient memory to run FPDemo."
      END
    CASE 24, 25, 27
      Chk$ = DialogBoxM$(TimeOut$(), EBox, "Time Out", 0)
      IF ASCII(Chk$) = 27 THEN
	RESUME NEXT
      ELSE
	RESUME 0
      END IF
    CASE 61
      Chk$ = DialogBoxM$(DiskFull$(), EBox, "Disk Full", 0)
    CASE 70, 71, 72
      Chk$ = DialogBoxM$(DiskError$(), EBox, "Disk Error", 0)
      IF ASCII(Chk$) = 27 THEN
	RESUME NEXT
      ELSE
	RESUME 0
      END IF
    CASE ELSE	' an untrapped error occurred
      COLOR %White, %Black
      CLS
      PRINT "A fatal error occurred."
      PRINT ErrorName$(ERR)
      PRINT "Location:"; ERADR
      ON ERROR GOTO 0
      END
  END SELECT
  ON ERROR GOTO 0	' fatal error

' end of ErrorTrap subroutine
